function init(hero) {
    hero.setName("Doctor Vegetable");
    hero.setTier(7);
    
    hero.setHelmet("Head");
    hero.setChestplate("Coat");
    hero.setLeggings("Pants");
    hero.setBoots("Shoes");
    
    hero.addPowers("smp:vegetable_physiology");
    hero.addAttribute("PUNCH_DAMAGE", 11, 0);
    hero.addAttribute("JUMP_HEIGHT", 1, 0);
    hero.addAttribute("FALL_RESISTANCE", 1, 1);
    hero.addAttribute("SPRINT_SPEED", 0.4, 1);

    hero.addKeyBind("CHARGED_BEAM", "Vegetable Eyes", 1);
    hero.addKeyBind("TELEKINESIS", "key.telekinesis", 2);
    hero.addKeyBind("VEGGIE_TRANSFORM", "Vegetable Transformation", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() != "fiskheroes:transformation" && (!entity.getData("fiskheroes:dyn/nanites") || modifier.name() == "fiskheroes:controlled_flight" && entity.getData("fiskheroes:dyn/nanite_timer") < 1)) {
        return false;
    }

    switch (modifier.name()) {
        case "fiskheroes:controlled_flight":
            return entity.getData("fiskheroes:dyn/nanites");
        default:
            return true;
    }
}

function isKeyBindEnabled(entity, keyBind) {
    if (keyBind == "VEGGIE_TRANSFORM") {
        return true;
    }
    else if (!entity.getData("fiskheroes:dyn/nanites")) {
        return false;
    }

    switch (keyBind) {
        case "CHARGED_BEAM":
            return !entity.getData("fiskheroes:telekinesis");
        default:
            return true;
    }
}