function init(hero) {
    hero.setName("The Orange Bat");
    hero.setTier(6);

    hero.setHelmet("item.superhero_armor.piece.cowl");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    hero.addPrimaryEquipment("fiskheroes:grappling_gun", true);
    hero.addPrimaryEquipment("fisktag:weapon{WeaponType:smp:the_orange_bat_pistol}", true, item => item.nbt().getString("WeaponType") == "smp:the_orange_bat_pistol");

    hero.addPowers("smp:the_orange_bat_suit");
    hero.addAttribute("PUNCH_DAMAGE", 6.5, 0);
    hero.addAttribute("WEAPON_DAMAGE", 3.5, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 6.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);
    hero.addAttribute("IMPACT_DAMAGE", 0.5, 1);

    hero.addKeyBind("AIM", "key.aim", -1);
    hero.addKeyBind("UTILITY_BELT", "key.utilityBelt", 1);
    hero.addKeyBind("CHARGED_JUMP", "Charged Jump", 5);

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setHasPermission((entity, permission) => permission == "USE_GRAPPLING_GUN" || permission == "ORANGE_BAT_PISTOL");
    hero.supplyFunction("canAim", entity => entity.getHeldItem().nbt().getString("WeaponType") == "smp:the_orange_bat_pistol");

    hero.addAttributeProfile("JUMP_1", firstJumpProfile);
    hero.addAttributeProfile("JUMP_2", secondJumpProfile);
    hero.addAttributeProfile("JUMP_3", thirdJumpProfile);
    hero.setAttributeProfile(getProfile);
}

function isKeyBindEnabled(entity, keyBind) {
    if (keyBind == "CHARGED_JUMP") {
        return entity.isOnGround();
    } else {
        return true;
    }
}

function getProfile(entity) {
    var j = entity.getData("smp:dyn/jump_timer")
    return j == 1 ? "JUMP_3" : j >= 1 / 1.5 ? "JUMP_2" : j >= 1 / 3 ? "JUMP_1" : null;
}

function firstJumpProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("JUMP_HEIGHT", 5.3, 0);
}

function secondJumpProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("JUMP_HEIGHT", 10.7, 0);
}

function thirdJumpProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("JUMP_HEIGHT", 16.0, 0);
}