function init(hero) {
    hero.setName("The Undying");
    hero.setTier(9);

    hero.setHelmet("item.superhero_armor.piece.head");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("smp:the_undying");
    hero.addAttribute("PUNCH_DAMAGE", 5.5, 0);
    hero.addAttribute("WEAPON_DAMAGE", 3.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 4.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.1, 1);
    hero.addAttribute("IMPACT_DAMAGE", 0.3, 1);

    hero.addKeyBind("AIM", "key.energyProjection", 1);
    hero.addKeyBind("ENERGY_PROJECTION", "key.energyProjection", 1);
    hero.addKeyBind("CHARGE_ENERGY", "key.chargeEnergy", 2);
    hero.addKeyBind("BLADE", "Toggle Staff", 5);

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.supplyFunction("canAim", canAim);
    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getProfile);
    hero.setDamageProfile(getProfile);
    hero.addDamageProfile("BLADE", {"types": {"MAGIC>": 0.25}});

    hero.addSoundEvent("AIM_START", "fiskheroes:mysterio_beam_aim");

    hero.setTickHandler((entity, manager) => {
        var flying = entity.getData("fiskheroes:flying");
        manager.incrementData(entity, "fiskheroes:dyn/booster_timer", 2, flying);
        manager.incrementData(entity, "fiskheroes:dyn/wing_timer", 6, 7, flying);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "AIM":
    case "CHARGE_ENERGY":
        return !(entity.getData("fiskheroes:flying") && entity.isSprinting()) && entity.getData("fiskheroes:blade");
    case "ENERGY_PROJECTION":
        return entity.getData("fiskheroes:aimed_timer") >= 1;
    default:
        return true;
    }
}

function canAim(entity) {
    return entity.getData("fiskheroes:blade");
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 8.0, 0);
}

function getProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}
