extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:doctor_vegetable_layer1",
    "layer2": "smp:doctor_vegetable_layer2",
    "cape": "smp:doctor_vegetable_cape",
    "transform": "smp:doctor_vegetable_transform"
});
var utils = implement("fiskheroes:external/utils");
var capes = implement("fiskheroes:external/capes");

var cape;
var transform;

function initEffects(renderer) {
    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:war_cry", "head", 0x3B932F, [
        { "firstPerson": [2.2, 0.0, 2.0], "offset": [2.2, -3.3, -4.0], "size": [1.0, 0.5] },
        { "firstPerson": [-2.2, 0.0, 2.0], "offset": [-2.2, -3.3, -4.0], "size": [1.0, 0.5] }
    ]);

    var physics = renderer.createResource("CAPE_PHYSICS", null);
    physics.maxFlare = 0.4;
    cape = capes.createDefault(renderer, 24, "fiskheroes:cape_default.mesh.json", physics);
    cape.effect.texture.set("cape");
    cape.effect.width = 12;

    utils.bindCloud(renderer, "fiskheroes:telekinesis", "smp:vegetable");

    transform = renderer.createEffect("fiskheroes:overlay");
    transform.texture.set("transform");
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    utils.addFlightAnimation(renderer, "drVeggie.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "drVeggie.HOVER", "fiskheroes:flight/idle/neutral");
}

function render(entity, renderLayer, isFirstPersonArm) {
    transform.render();
    transform.opacity = entity.getInterpolatedData("fiskheroes:dyn/nanite_timer");
    if (!isFirstPersonArm && renderLayer == "CHESTPLATE" && entity.getData("fiskheroes:dyn/nanites")) {
        cape.render(entity);
    }
}