extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:the_conjurer_layer1",
    "layer2": "smp:the_conjurer_layer2",
    "flute": "smp:the_conjurer_flute",
    "flute_lights": "smp:the_conjurer_flute_lights",
    "cape": "smp:the_conjurer_cape"
});

var utils = implement("fiskheroes:external/utils");
var capes = implement("fiskheroes:external/capes");

var cape;

function initEffects(renderer) {
    var physics = renderer.createResource("CAPE_PHYSICS", null);
    physics.maxFlare = 0.4;
    cape = capes.createDefault(renderer, 24, "fiskheroes:cape_default.mesh.json", physics);
    cape.effect.texture.set("cape");
    cape.effect.width = 12;

    utils.bindBeam(renderer, "fiskheroes:lightning_cast", "smp:heal", "rightArm", 0xFCE42F, [
        { "firstPerson": [-8.0, 4.5, -10.0], "offset": [-0.5, 9.0, 0.0], "size": [0.75, 0.75] }
    ]);

    utils.bindBeam(renderer, "fiskheroes:charged_beam", null, "body", 0x4556C0, [])

    var model = renderer.createResource("MODEL", "smp:the_conjurer_flute");
    model.bindAnimation("smp:the_conjurer_flute")
        .setData((entity, data) => {
            data.load(entity.getInterpolatedData("fiskheroes:beam_charge"));
        })
    model.texture.set("flute", "flute_lights");
    flute = renderer.createEffect("fiskheroes:model").setModel(model);
    flute.anchor.set("rightArm");
    flute.setRotation(90, 0, 0);
    flute.setOffset(1, 8, -18)

    utils.bindParticles(renderer, "smp:the_conjurer").setCondition(entity => entity.getData("fiskheroes:flying"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);

    addAnimationWithData(renderer, "conjurer.FLUTE", "smp:the_conjurer_flute", "fiskheroes:beam_charge");

    utils.addHoverAnimation(renderer, "conjurer.HOVER", "fiskheroes:flight/idle/neutral");
    utils.addFlightAnimation(renderer, "conjurer.FLIGHT", "smp:flight/levitate.anim.json", (entity, data) => {
        data.load(entity.getInterpolatedData("fiskheroes:flight_timer"));
    });
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (!isFirstPersonArm && renderLayer == "CHESTPLATE") {
        cape.render(entity);
    }
    if (entity.getData("fiskheroes:blade")) {
        flute.render();
    }
}